#include <iostream>
#include <string>

using namespace std;

const int MaxN = 100+1;

char map[MaxN][MaxN];
int hor[MaxN], ver[MaxN];

int k, l, n, m;

inline void print_no_and_exit(){
  cout << "NONE";
  fclose(stdin);
  fclose(stdout);
  exit(0);
}

inline bool in_range(int& i, int&j){
  return 0 <= i && i < n && 0 <= j && j < m;
}

void check(int i, int j){
  if(hor[j] != -1){
    int di = hor[j] - i;
    int ni = hor[j] + di;
    if(!in_range(ni, j)){
      map[i][j] = '.';
    }
    if(ni > i && in_range(ni, j)){
      check(ni, j);
    }
    if(map[ni][j] == '.'){
      map[i][j] = '.';
    }
  }
  if(ver[i] != -1){
    int dj = ver[i] - j;
    int nj = ver[i] + dj;
    if(!in_range(i, nj)){
      map[i][j] = '.';
    }
    if(nj > j && in_range(i, nj)){
      check(i, nj);
    }
    if(map[i][nj] == '.'){
      map[i][j] = '.';
    }
  }
}

bool solution_found(){
  for(int i = 0; i < n; i++){
    if(ver[i] != -1){
      bool found = false;
      for(int j = 0; j < m; j++){
        if(map[i][j] == '#'){
          found = true;
          break;
        }
      }
      if(!found){
        return false;
      }
    }
  }
  for(int j = 0; j < m; j++){
    if(hor[j] != -1){
      bool found = false;
      for(int i = 0; i < n; i++){
        if(map[i][j] == '#'){
          found = true;
          break;
        }
      }
      if(!found){
        return false;
      }
    }
  }
  return true;
}

int main(){
  memset(hor, 255, sizeof(hor));
  memset(ver, 255, sizeof(ver));
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin >> m >> n;
  for(int i = 0; i < n; i++){
    for(int j = 0; j < m; j++){
      cin >> map[i][j];
      if(map[i][j] == '-' || map[i][j] == '+'){
        if(hor[j] != -1){
          print_no_and_exit();
        }
        hor[j] = i;
      }
      if(map[i][j] == '|' || map[i][j] == '+'){
        if(ver[i] != -1){
          print_no_and_exit();
        }
        ver[i] = j;
      }
      map[i][j] = '#';
    }
  }
  bool change = true;
  while(change){
    change = false;
    for(int i = 0; i < n; i++){
      for(int j = 0; j < m; j++){
        if(map[i][j] == '#'){
          check(i, j);
          if(map[i][j] != '#'){
            change = true;
          }
        }
      }
    }
  }
  if(!solution_found()){
    print_no_and_exit();
  }
  for(int i = 0; i < n; i++){
    for(int j = 0; j < m; j++){
      cout << map[i][j];
    }
    cout << endl;
  }
  fclose(stdin);
  fclose(stdout);
  return 0;
}
